// > sort 3
import {LANGUAGE} from "../build/main.mjs";

export var DONE = 1;

export var get = {
    now: 0,
    ticks: getTicks,
    cpu: getCpuTime,
    heap: getHeapStatistics,
    byid: getObjectById,
    handle: function(){
        get.now = getTicks();
        get.ALL_THIS_TICK_TABLE = {};
    },
    cpu_us: function () {
        return Math.floor(getCpuTime() / 1000);
    },
    get arena() {
        return function () {
            var tmp = UsrObject();
            tmp.py_name = ARENA_NAME;
            tmp.level = ARENA_LEVEL;
            tmp.season = ARENA_SEASON;
            tmp.ticksLimit = ARENA_TICKS_LIMIT;
            tmp.cpuTimeLimit = ARENA_CPU_TIME_LIMIT;
            tmp.cpuTimeLimitFirstTick = ARENA_CPU_TIME_LIMIT_FIRST_TICK;
            return tmp;
        };
    },
    path: function (obj, target, options = null) {
        if (target === null || target === undefined) {
            if (LANGUAGE === "cn") std.warn('get.path', '目标{target}为空。返回null');
            else std.warn('get.path', 'target is NA. Return null');
            return null;
        }
        if (obj === null || obj === undefined) {
            if (LANGUAGE === "cn") std.warn('get.path', '对象为空{obj}。返回null');
            else std.warn('get.path', 'obj is NA. Return null');
            return null;
        }
        var path_res = searchPath(obj, target, options);
        // if (path_res.incomplete) {
        //     if (LANGUAGE === "cn") std.warn('get.path', '目标{' + target.id.toString() + '}的路径不完整。');
        //     else std.warn('get.path', 'Path to target:', target.id, ' is incomplete.');
        // }
        return path_res.path;
    },
    find: function (objs, filter_fn) {
        if (len(objs) === 0) {
            return null;
        }
        if (filter_fn === undefined || filter_fn === null) {
            if (LANGUAGE === "cn") std.warn('get.find', '过滤函数为空。默认返回第一个对象');
            else std.warn('get.find', 'filter_fn is NA. Return first object');
        } else {
            if (isinstance(filter_fn, tuple([list, tuple, set]))) {
                filter_fn = std.combo(filter_fn);
            }
            objs = filter(filter_fn, objs);
        }
        return len(objs) ? objs[0] : null;
    },
    filter: function (objs, filter_fn) {
        if (len(objs) === 0) {
            return objs;
        }
        if (filter_fn === undefined || filter_fn === null) {
            if (LANGUAGE === "cn") std.warn('get.filter', '过滤函数为空。返回原数组|列表。');
            else std.warn('get.filter', 'filter_fn is NA. Return the original array|list.');
        } else {
            if (isinstance(filter_fn, tuple([list, tuple, set]))) {
                filter_fn = std.combo(filter_fn);
            }
            return filter(filter_fn, objs);
        }
        return objs;
    },
    terrain: function (x_or_point, y) {
        if (x_or_point === null || x_or_point === undefined) {
            if (LANGUAGE === "cn") std.warn('get.terrain', 'x_or_point为空。返回null');
            else std.warn('get.terrain', 'x_or_point is NA. Return null');
            return null;
        }
        if (y === null || y === undefined) {
            if (x_or_point.x === undefined || x_or_point.y === undefined) {
                if (LANGUAGE === "cn") std.warn('get.terrain', 'x_or_point不是一个点。返回null');
                else std.warn('get.terrain', 'x_or_point is not a point. Return null');
                return null;
            }

            return getTerrainAt(x_or_point);
        }
        return getTerrainAt(Point(x_or_point, y));
    },
    ALL_THIS_TICK_TABLE: {},
    all: function (p_type, filter_fn = null) {
        let objs = get.ALL_THIS_TICK_TABLE[p_type.name];
        if (objs === undefined) {
            objs = getObjectsByPrototype(p_type);
            const tmp = [];

            for (const obj of objs) {
                if (!obj.__py__){
                    const pyembed = PYEMBED_TABLE[obj.constructor.name];
                    if (pyembed !== undefined) {
                        obj.__py__ = new pyembed(obj);
                    } else {
                        obj.__py__ = obj;
                        obj.__object__ = obj;
                    }
                }
                if (obj instanceof GameCreep) {
                    // if ((obj.my === false) || (obj.__spawn__ !== undefined)) {
                    if (obj.__py__.birthed) {
                        tmp.append(obj.__py__);
                    }
                } else tmp.append(obj.__py__);
            }
            objs = tmp;
        }

        if (filter_fn !== undefined && filter_fn !== null) {
            if (isinstance(filter_fn, tuple([list, tuple, set]))) {
                filter_fn = std.combo(filter_fn);
            }
            objs = filter(filter_fn, objs);
        }
        return objs;
    },
    one: function (p_type, filter_fn = null) {
        var objs = get.all(p_type, filter_fn);
        if (len(objs) === 0) {
            return null;
        }
        return objs[0];
    },
    creeps: function (filter_fn = null) {
        return get.all(GameCreep, filter_fn);
    },
    creep: function (filter_fn = null) {
        return get.one(GameCreep, filter_fn);
    },
    friends: function (filter_fn = null) {
        return get.all(GameCreep, function (obj) {
            return obj.my && (!(filter_fn) || filter_fn(obj));
        });
    },
    friend: function (filter_fn = null) {
        return get.one(GameCreep, function (obj) {
            return obj.my && (!(filter_fn) || filter_fn(obj));
        });
    },
    enemies: function (filter_fn = null) {
        return get.all(GameCreep, function (obj) {
            return !(obj.my) && (!(filter_fn) || filter_fn(obj));
        });
    },
    enemy: function (filter_fn = null) {
        return get.one(GameCreep, function (obj) {
            return !(obj.my) && (!(filter_fn) || filter_fn(obj));
        });
    },
    spawns: function (filter_fn = null) {
        return get.all(GameStructureSpawn, filter_fn);
    },
    spawn: function (filter_fn = null) {
        return get.one(GameStructureSpawn, filter_fn);
    },
    structures: function (filter_fn = null) {
        return get.all(GameStructure, filter_fn);
    },
    structure: function (filter_fn = null) {
        return get.one(GameStructure, filter_fn);
    },
    sources: function (filter_fn = null) {
        return get.all(GameSource, filter_fn);
    },
    source: function (filter_fn = null) {
        return get.one(GameSource, filter_fn);
    },
    sites: function (filter_fn = null) {
        return get.all(GameConstructionSite, filter_fn);
    },
    site: function (filter_fn = null) {
        return get.one(GameConstructionSite, filter_fn);
    },
    resources: function (filter_fn = null) {
        return get.all(GameResource, filter_fn);
    },
    resource: function (filter_fn = null) {
        return get.one(GameResource, filter_fn);
    },
    towers: function (filter_fn = null) {
        return get.all(GameStructureTower, filter_fn);
    },
    tower: function (filter_fn = null) {
        return get.one(GameStructureTower, filter_fn);
    },
    walls: function (filter_fn = null) {
        return get.all(GameStructureWall, filter_fn);
    },
    wall: function (filter_fn = null) {
        return get.one(GameStructureWall, filter_fn);
    },
    ramparts: function (filter_fn = null) {
        return get.all(GameStructureRampart, filter_fn);
    },
    rampart: function (filter_fn = null) {
        return get.one(GameStructureRampart, filter_fn);
    },
    extensions: function (filter_fn = null) {
        return get.all(GameStructureExtension, filter_fn);
    },
    extension: function (filter_fn = null) {
        return get.one(GameStructureExtension, filter_fn);
    },
    boxes: function (filter_fn = null) {
        return get.all(GameStructureContainer, filter_fn);
    },
    box: function (filter_fn = null) {
        return get.one(GameStructureContainer, filter_fn);
    },
    roads: function (filter_fn = null) {
        return get.all(GameStructureRoad, filter_fn);
    },
    road: function (filter_fn = null) {
        return get.one(GameStructureRoad, filter_fn);
    },
    flags: function (filter_fn = null) {
        return get.all(GameFlag, filter_fn);
    },
    flag: function (filter_fn = null) {
        return get.one(GameFlag, filter_fn);
    },
    gobjects: function (filter_fn = null) {
        return get.all(GameObjectProto, filter_fn);
    },
    gobject: function (filter_fn = null) {
        return get.one(GameObjectProto, filter_fn);
    },
    bodyParts: function (filter_fn = null) {
        return get.all(GameBodyPart, filter_fn);
    },
    bodyPart: function (filter_fn = null) {
        return get.one(GameBodyPart, filter_fn);
    },
    scoreCollectors: function (filter_fn = null) {
        return get.all(GameScoreCollector, filter_fn);
    }, 
    scoreCollector: function (filter_fn = null) {
        return get.one(GameScoreCollector, filter_fn);
    },
    areaEffects: function (filter_fn = null) {
        return get.all(GameAreaEffect, filter_fn);
    },
    areaEffect: function (filter_fn = null) {
        return get.one(GameAreaEffect, filter_fn);
    },

    store: function (target, resource_type, percent = false) {
        if (target === null || !(target.store)) {
            if (LANGUAGE === "cn") std.warn('get.store', '目标为空或不是一个存储对象。返回-1; target:', target);
            else std.warn('get.store', 'target is NA or not a storable object. Return -1; target:', target);
            return -(1);
        }
        var current = target.store.getUsedCapacity(resource_type);
        if (current === null) {
            if (LANGUAGE === "cn") std.warn('get.store', `目标${target}不包含资源${resource_type}。返回-1`);
            else std.warn('get.store', 'target:', target, 'does not contain resource:', resource_type, '. Return -1');
            return -(1);
        }
        var value = current;
        if (percent) {
            var total = target.store.getCapacity(resource_type);
            if (total === null) {
                if (LANGUAGE === "cn") std.warn('get.store', `目标${target}不包含资源${resource_type}。返回-1`);
                else std.warn('get.store', 'target:', target, 'does not contain resource:', resource_type, '. Return -1');
                return -(1);
            }
            value = current / total
        }
        return value;
    },
    energy: function (target, percent = false) {
        return get.store(target, RESOURCE_ENERGY, percent)
    },
    score: function (target, percent = false) {
        return get.store(target, RESOURCE_SCORE, percent)
    },
    scoreX: function (target, percent = false) {
        return get.store(target, RESOURCE_SCORE_X, percent)
    },
    scoreY: function (target, percent = false) {
        return get.store(target, RESOURCE_SCORE_Y, percent)
    },
    scoreZ: function (target, percent = false) {
        return get.store(target, RESOURCE_SCORE_Z, percent)
    },
    health: function (target, percent = false) {
        if (target === null) {
            return 0;
        }
        if (target.hits === undefined) {
            return 0;
        }
        var current = target.hits;
        var value = current;
        if (percent) {
            if (target.hitsMax === undefined) {
                return 0;
            }
            var total = target.hitsMax;
            value = current / total
        }
        return value;
    },
    wait: function (creep) {
        var move_count = get.partCount(creep, MOVE, false);
        if (move_count === -1) {
            return -1;
        }
        if (move_count === 0) {
            return 65535;
        }
        var fatigue = creep.fatigue;
        if (fatigue <= 0) {
            return 0;
        }
        return Math.ceil((fatigue / 2) / move_count);
    },
    situation: function (){
        // 获取场上存活的双方出兵的情况
        /*
        * this.creepHistory = {
            enemies:{
                vector: new PartsVector([]),
                count: 0,
                grade: 0,
            },
            friends:{
                vector: new PartsVector([]),
                count: 0,
                grade: 0,
            }
        }
        * */
        return Monitor().creepHistory;
    },
    SCORE_COLLECTORS: null,
    controlled: function () {
        if (get.SCORE_COLLECTORS === null) {
            get.SCORE_COLLECTORS = get.scoreCollectors();
        }
        if (get.SCORE_COLLECTORS.length === 0) {
            return undefined;
        }
        // return True if all .my is True
        for (const obj of get.SCORE_COLLECTORS) {
            if (!obj.my) return false;
        }
        return true;
    },

    /// MACHINE -------------------------------------------------------------------
    clusters: function (objs, dist = 3, minPts = 2) {
        const clusters = [];
        const visited = new Set();

        // 主算法
        for (let i = 0; i < objs.length; i++) {
            const obj = objs[i];
            if (visited.has(obj)) continue;
            visited.add(obj);

            // 获取邻域内的点
            const neighbors = objs.filter(other => (obj.distance(other) <= dist && other !== obj));
            if (neighbors.length < (minPts - 1)) {
                continue; // 不满足最小点数要求，跳过
            }

            const cluster = {x: 0, y: 0, grade: obj.grade!==undefined?obj.grade:0, objects: [obj]};
            clusters.push(cluster);

            // 使用队列来处理邻域扩展
            const queue = neighbors;
            while (queue.length > 0) {
                const current = queue.shift();
                if (!visited.has(current)) {
                    visited.add(current);
                    const currentNeighbors = objs.filter(other => (current.distance(other) <= dist && other !== current));
                    if (currentNeighbors.length >= minPts) {
                        queue.push(...currentNeighbors);
                    }
                }
                if (!cluster.objects.includes(current)) {
                    cluster.objects.push(current);
                    cluster.grade += current.grade!==undefined?current.grade:0;
                }
            }

            // 更新簇的质心
            const centroid = Point.fcenter(...cluster.objects);
            cluster.x = centroid.x;
            cluster.y = centroid.y;
        }


        // 所有质心取round
        for (const cluster of clusters) {
            cluster.x = Math.round(cluster.x);
            cluster.y = Math.round(cluster.y);
        }

        return clusters;
    },

    /// GRAPH -------------------------------------------------------------------
    DEGREE_TABLE_REFLECT: { // (360 / 45) -> Direction
        0: RIGHT,
        1: TOP_RIGHT,
        2: TOP,
        3: TOP_LEFT,
        4: LEFT,
        5: BOTTOM_LEFT,
        6: BOTTOM,
        7: BOTTOM_RIGHT,
    },
    direction: function (vec_point, target = undefined) {
        /**
         * 根据给定的向量点确定其方向。
         *
         * 该函数通过计算向量与 x 轴正方向之间的角度，将角度映射到八个基本方向之一：
         * `RIGHT`、`TOP_RIGHT`、`TOP`、`TOP_LEFT`、`LEFT`、`BOTTOM_LEFT`、`BOTTOM`、`BOTTOM_RIGHT`。
         *
         * 如果提供了目标点 `target`，函数会计算从 `vec_point` 到 `target` 的向量。
         * 否则，它将使用 `vec_point` 作为相对于原点的向量。
         *
         * 角度计算使用 `math.atan2(y, x)`，结果以弧度为单位，然后转换为度数。
         * 负角度会加上 360 度，使其在 [0, 360) 度范围内。
         *
         * 为了将角度映射到八个方向，函数将角度加上 22.5 度，以对齐方向边界，
         * 然后除以 45 度并取整，找到最接近的方向索引。
         * 这样可以确保角度均匀分布在各个方向之间。
         *
         * 最后，函数使用 `DEGREE_TABLE_REFLECT` 表返回对应的方向。
         *
         * @param {Point} vec_point - 表示向量的点。
         * @param {Point} [target] - 可选的目标点，用于计算相对向量。
         * @returns {String} - 八个基本方向之一的名称。
         */
        if (target !== undefined) {
            vec_point = Point(target.x - vec_point.x, target.y - vec_point.y);
        }
        let x = vec_point.x, y = vec_point.y;
        let theta = -math.atan2(y, x);  // 计算弧度
        let dtheta = math.degree(theta);  // 转换为度

        // 将角度范围调整到 [0, 360)
        if (dtheta < 0)
            dtheta += 360

        // 计算最接近的方向
        let dir_idx = math.floor((dtheta + 22.5) / 45) % 8

        return get.DEGREE_TABLE_REFLECT[dir_idx]
    },
    OPPOSITE_MAP: {  // Direction -> Direction
        1: 5,
        2: 6,
        3: 7,
        4: 8,
        5: 1,
        6: 2,
        7: 3,
        8: 4,
    },
    reversedDirection: function (direction) {
        const ret = get.OPPOSITE_MAP[direction];
        if (ret === undefined) {
            if (LANGUAGE === "cn") std.warn("get.reversedDirection", "未知的方向:", direction);
            else std.warn("get.reversedDirection", "Unknown direction:", direction);
            return 1;
        }
        return ret;
    },
    expandDirection: function (direction) {
        return [direction, (direction + 6) % 8 + 1, direction % 8 + 1];
    },
    DIRECTION_TO_ANGLE: {  // Direction -> Angle
        [TOP]: 270,  // TOP实际上是-y轴方向
        [TOP_RIGHT]: 315,
        [RIGHT]: 0,
        [BOTTOM_RIGHT]: 45,
        [BOTTOM]: 90,
        [BOTTOM_LEFT]: 135,
        [LEFT]: 180,
        [TOP_LEFT]: 225,
    },
    directionAngle: function (direction) {
        /// 根据给定的方向返回对应的角度。
        /// 如果方向无效，记录错误并返回0度。
        const ret = get.DIRECTION_TO_ANGLE[direction];
        if (ret === undefined) {
            if (LANGUAGE === "cn") std.warn("get.directionAngle", "未知的方向:", direction);
            else std.warn("get.directionAngle", "Unknown direction:", direction);
            return 0;
        }
        return ret;
    },
    directionDelta: function (direction0, direction1) {
        /// 计算从 direction0 到 direction1 的方向变化。
        /// 返回值是角度差异，确保为正数且为45度的倍数。
        /// 如果任何一个方向无效，记录错误并返回0度。
        const a0 = get.DIRECTION_TO_ANGLE[direction0];
        const a1 = get.DIRECTION_TO_ANGLE[direction1];
        if (a0 === undefined || a1 === undefined) {
            if (LANGUAGE === "cn") std.warn("get.directionDelta", "未知的方向:", direction0, direction1);
            else std.warn("get.directionDelta", "Unknown direction:", direction0, direction1);
            return 0;
        }
        let delta = a1 - a0;
        if (delta < 0) delta += 360;
        return delta;
    },
    DIRECTION_TO_DELTAPIONT: {  // Direction -> Point
        1: {x: 0, y: -1},
        2: {x: 1, y: -1},
        3: {x: 1, y: 0},
        4: {x: 1, y: 1},
        5: {x: 0, y: 1},
        6: {x: -1, y: 1},
        7: {x: -1, y: 0},
        8: {x: -1, y: -1},
    },
    directionPoint: function (direction, base_point = undefined) {
        let point = get.DIRECTION_TO_DELTAPIONT[direction];
        if (base_point !== undefined) {
            return {x: base_point.x + point.x, y: base_point.y + point.y};
        }
        return point;
    },
    pooling: function (tarArr, kernelSize = 2) {
        /**
         * Pooling the array with kernelSize and stride with 'mean'
         *
         * @param {number[][]} tarArr - The target array
         * @param {number} kernelSize - The size of the kernel, strides will equal to kernelSize
         * @returns {number[][]} The pooled array
         */
        if (kernelSize < 2) {
            if (LANGUAGE === "cn") std.error("get.pooling", "池化核大小应大于1:", kernelSize);
            else std.error("get.pooling", "Kernel size should be greater than 1:", kernelSize);
        }
        if (tarArr.length < kernelSize || tarArr[0].length < kernelSize) {
            if (LANGUAGE === "cn") std.error("get.pooling", "数组大小应大于池化核大小:", len(tarArr), len(tarArr[0]));
            else std.error("get.pooling", "Array size should be greater than kernel size:", len(tarArr), len(tarArr[0]));
        }
        const res = [];
        const kSquare = kernelSize ** 2;
        const lenH = (Math.floor(tarArr.length / kernelSize)) * kernelSize;
        const lenW = (Math.floor(tarArr[0].length / kernelSize)) * kernelSize;
        for (let i = 0; i < lenH; i += kernelSize) {
            const newLine = [];
            for (let j = 0; j < lenW; j += kernelSize) {
                let sum = 0;
                for (let k = 0; k < kernelSize; k++) {
                    for (let l = 0; l < kernelSize; l++) {
                        sum += tarArr[i + k][j + l];
                    }
                }
                newLine.push(Math.floor(sum / kSquare));
            }
            res.push(newLine);
        }
        return res;
    },
    COST_ARRAY2D: [],
    COST_MATRIX : new CostMatrix(),
    costArray2D: function (start = {x: 0, y: 0}, end = {x: 100, y: 100}, __new__ = false) {
        // 这个函数返回整个地图的对应roi区域的拷贝
        const ret = [];
        if (__new__) {
            for (let j = start.y; j < end.y; j++) {
                const newLine = [];
                for (let i = start.x; i < end.x; i++) {
                    const terrain = get.terrain(i, j);

                    if (terrain === TERRAIN_PLAIN) {
                        newLine.push(2);
                    } else if (terrain === TERRAIN_SWAMP) {
                        newLine.push(10);
                    } else {
                        newLine.push(255);
                    }
                }
                ret.push(newLine);
            }
            return ret;
        } else {
            for (let j = 0; j < end.y; j++) {
                const newLine = [];
                for (let i = start.x; i < end.x; i++) {
                    newLine.push(get.COST_ARRAY2D[j][i]);
                }
                ret.push(newLine);
            }
            return ret;
        }
    },
    shape: function (arr) {
        let rows = len(arr);
        if (rows === 0) return {x: 0, y: 0};
        return {x: len(arr[0]), y: rows};
    },
    slice2d: function (arr, start = {x: 0, y: 0}, end = undefined) {
        const ret = [];
        if (end === undefined) end = get.shape(arr);
        for (let j = start.y; j < end.y; j++) {
            const newLine = [];
            for (let i = start.x; i < end.x; i++) {
                newLine.push(arr[j][i]);
            }
            ret.push(newLine);
        }
        return ret;
    },
    min2d: function (arr) {
        let min = Infinity;
        for (let i = 0; i < len(arr); i++) {
            min = Math.min(min, Math.min(...arr[i]));
        }
        return min;
    },
    max2d: function (arr) {
        let max = -Infinity;
        for (let i = 0; i < len(arr); i++) {
            max = Math.max(max, Math.max(...arr[i]));
        }
        return max;
    },
    sum2d: function (arr) {
        let sum = 0;
        for (let i = 0; i < len(arr); i++) {
            sum += sum(arr[i]);
        }
        return sum;
    },
    mean2d: function (arr) {
        return get.sum2d(arr) / (len(arr) * len(arr[0]));
    },
    poolingPrefab: function (psize) {
        if (psize === 1) return get.COST_ARRAY2D;
        if (psize === 2) return get.P2;
        if (psize === 4) return get.P4;
        if (psize === 5) return get.P5;
        if (psize === 8) return get.P8;
        if (psize === 10) return get.P10;
        // throw new Error("psize should be 1, 2, 4, 5, 8 or 10. Got: " + psize);
        if (LANGUAGE === "cn") std.error("get.poolingPrefab", "psize应为1, 2, 4, 5, 8或10。得到:", psize);
        else std.error("get.poolingPrefab", "psize should be 1, 2, 4, 5, 8 or 10. Got:", psize);
    },
    space: function (tx, ty, rot = 0) {
        /**
         * Find a 1x1 space with the base point tx, ty
         *
         * @param {number} tx - the x position of the 100x100 space
         * @param {number} ty - the y position of the 100x100 space
         * @param {number} rot - 0/1, indicating the spiral direction, 0 for counterclockwise left, 1 for counterclockwise right
         *
         * @returns {Object} the position of the 1x1 space
         */

        let pool = get.poolingPrefab(1); // Assuming getPooling is defined elsewhere
        let shape = get.shape(pool);
        const width = shape.x;
        const height = shape.y;

        let tix = tx;
        let tiy = ty;
        let step = 1;
        let dirId = 0;
        let bestVal = 255;
        let bestPos = { x: tx, y: ty };

        // Determine the spiral direction based on the rot parameter
        let directs;
        if (rot) {
            directs = [[-1, 0], [0, 1], [1, 0], [0, -1]]; // Spiral direction: counterclockwise right
        } else {
            directs = [[1, 0], [0, -1], [-1, 0], [0, 1]]; // Spiral direction: counterclockwise left
        }

        // Start spiral search from the target point, find the position with a value <= 10 and return it. If not found, return the best position found.
        while (true) {
            for (let _ = 0; _ < 2; _++) {
                for (let _ = 0; _ < step; _++) {
                    if (0 <= tix && tix < width && 0 <= tiy && tiy < height) {
                        let val = pool[tiy][tix];
                        if (val <= 10) {
                            return Point(tix, tiy);
                        } else if (val < bestVal) {
                            bestVal = val;
                            bestPos = { x: tix, y: tiy };
                        }
                    } else if (tix < 0 || tix >= width || tiy < 0 || tiy >= height) {
                        return Point(bestPos.x, bestPos.y);
                    }
                    tix += directs[dirId][0];
                    tiy += directs[dirId][1];
                }
                dirId = (dirId + 1) % 4;
            }
            step += 1;
        }
    },
    space2x: function (psize, x, y, rot = 0) {
        /**
         * Find a 2x psize square space with the base point x, y
         *
         * @param {number} psize - the size of the pool. (1, 2, 4, 5, 8, 10) corresponding to search space sizes (2x2, 4x4, 8x8, 10x10, 16x16, 20x20)
         * @param {number} x - the x position of the 100x100 space
         * @param {number} y - the y position of the 100x100 space
         * @param {number} rot - 0/1, indicating the spiral direction, 0 for counterclockwise left, 1 for counterclockwise right
         *
         * @returns {Object} the lt position of the 2x2 space
         */

        function calcMean2x2(arr, tx, ty) {
            /**
             * Calculate the mean of the 2x2 area
             *
             * @param {Array} arr
             * @param {number} tx
             * @param {number} ty
             *
             * @returns {number}
             */
            let sum = 0;
            for (let i = 0; i < 2; i++) {
                for (let j = 0; j < 2; j++) {
                    sum += arr[ty + j][tx + i];
                }
            }
            return Math.floor(sum / 4);
        }

        let pool = get.poolingPrefab(psize); // Assuming getPooling is defined elsewhere
        let pSize = psize;

        const shape = get.shape(pool);
        const width = shape.x;
        const height = shape.y;
        let tix = Math.floor(x / pSize);
        let tiy = Math.floor(y / pSize);
        let step = 1;
        let dirId = 0;
        let bestVal = 255;
        let bestPos = {x: x, y: y};

        let directs;
        if (rot) {
            directs = [[-1, 0], [0, 1], [1, 0], [0, -1]];
        } else {
            directs = [[1, 0], [0, -1], [-1, 0], [0, 1]];
        }

        // Start spiral search from the target point, calculate the mean of each 2x2 area, find the position with a value <= 10 and return it. If not found, return tix, tiy
        while (true) {
            for (let _ = 0; _ < 2; _++) {
                for (let _ = 0; _ < step; _++) {
                    if (0 <= tix && tix < (width - 1) && 0 <= tiy && tiy < (height - 1)) {
                        let val = calcMean2x2(pool, tix, tiy);
                        if (val <= 10) {
                            return Point(tix * pSize, tiy * pSize);
                        } else if (val < bestVal) {
                            bestVal = val;
                            bestPos = {x: tix * pSize, y: tiy * pSize};
                        }
                    } else if ((tix < 0 || tix >= width - 1) && (tiy < 0 || tiy >= height - 1)) {
                        return Point(bestPos.x, bestPos.y);
                    }
                    tix += directs[dirId][0];
                    tiy += directs[dirId][1];
                }
                dirId = (dirId + 1) % 4;
            }
            step += 1;
        }
    },
    CHEB_ROTATION45X_MATRIX: {
        0: [[1, 0], [0, 1]],
        45: [[1, -1], [1, 0]],
        90: [[0, -1], [1, 0]],
        135: [[-1, 0], [1, -1]],
        180: [[-1, 0], [0, -1]],
        225: [[-1, 1], [-1, 0]],
        270: [[0, 1], [-1, 0]],
        315: [[1, 0], [-1, 1]]
    },
    chebRotate45x(point, old_direction, new_direction) {
        /**
         * 将一个点根据给定的方向旋转到新的方向。
         *
         * 该函数接受一个点和两个方向（旧方向和新方向），计算它们之间的角度差，
         * 然后使用预定义的旋转矩阵将该点旋转相应的角度。
         *
         * @param {Point} point - 需要旋转的点，包含 x 和 y 坐标。
         * @param {Direction} old_direction - 点的原始方向。
         * @param {Direction} new_direction - 点需要旋转到的新方向。
         * @returns {Point} - 旋转后的点，包含新的 x 和 y 坐标。
         *
         * @example
         * const rotatedPoint = chebRotate45x({x: 1, y: 1}, RIGHT, TOP);
         * console.log(rotatedPoint); // {x: -1, y: 1}
         *
         * 注意：
         * - 该函数假设方向以 45 度为增量。
         * - 如果计算的角度差不在预定义的矩阵中，将抛出错误。
         * - 旋转矩阵是针对 45 度增量预计算的。
         */
        let angle_delta = get.directionAngle(new_direction) - get.directionAngle(old_direction);
        if (angle_delta < 0) angle_delta += 360;
        let matrix = get.CHEB_ROTATION45X_MATRIX[angle_delta];
        if (matrix === undefined)
            if (LANGUAGE === 'cn') std.error("get.chebRotate45x", "未知的旋转角度: " + angle_delta.toString());
            else std.error("get.chebRotate45x", "Unknown rotation angle: " + angle_delta.toString());
        // return {
        //     x: point.x * matrix[0][0] + point.y * matrix[0][1],
        //     y: point.x * matrix[1][0] + point.y * matrix[1][1]
        // };
        return Point(point.x * matrix[0][0] + point.y * matrix[0][1], point.x * matrix[1][0] + point.y * matrix[1][1]);
    },
    expandMapBlock: function (arr2d) {
        // 深拷贝原数组，防止修改原数组
        let newArr2d = arr2d.map(row => row.slice());

        const shape = get.shape(arr2d);
        const width = shape.x;
        const height = shape.y;


        // 边缘检测并标记
        for (let i = 0; i < height; i++) {
            for (let j = 0; j < width; j++) {
                if (arr2d[i][j] === 255) {
                    let isEdge = false;
                    for (let di = -1; di <= 1; di++) {
                        for (let dj = -1; dj <= 1; dj++) {
                            if (di === 0 && dj === 0) continue;
                            let ni = i + di, nj = j + dj;
                            if (ni < 0 || ni >= height || nj < 0 || nj >= width || arr2d[ni][nj] !== 255) {
                                isEdge = true;
                                break;
                            }
                        }
                        if (isEdge) break;
                    }
                    if (isEdge) {
                        newArr2d[i][j] = -1; // 用-1标记边缘的255单元格
                    }
                }
            }
        }

        // 膨胀操作并还原标记的边缘单元格
        for (let i = 0; i < height; i++) {
            for (let j = 0; j < width; j++) {
                if (newArr2d[i][j] === -1) { // 对标记的边缘单元格进行膨胀
                    newArr2d[i][j] = 255; // 先将标记的边缘单元格还原为255
                    for (let di = -1; di <= 1; di++) {
                        for (let dj = -1; dj <= 1; dj++) {
                            if (di === 0 && dj === 0) continue;
                            let ni = i + di, nj = j + dj;
                            if (ni >= 0 && ni < height && nj >= 0 && nj < width && newArr2d[ni][nj] !== 255) {
                                newArr2d[ni][nj] = 255;
                            }
                        }
                    }
                }
            }
        }

        return newArr2d;
    },
    boundingRect: function (pts) {
        let left = Infinity, right = -Infinity, top = Infinity, bottom = -Infinity;

        pts.forEach(pt => {
            if (pt.x < left) left = pt.x;
            if (pt.x > right) right = pt.x;
            if (pt.y < top) top = pt.y;
            if (pt.y > bottom) bottom = pt.y;
        });

        let center = {
            x: (left + right) / 2,
            y: (top + bottom) / 2
        };

        return Rect(
            left,
            top,
            right,
            bottom,
        );
    },
    findNarrow: function (arr2d, p0, p1, direct, length = -1, end = 255) {
        /**
         * Find the narrowest length from (p0, p1) towards direct
         *
         * @param {Array} arr2d - 二维数组
         * @param {Object} p0 - 点对象，包含x和y属性
         * @param {Object} p1 - 点对象，包含x和y属性
         * @param {number} direct - 方向，只支持4个轴方向
         * @param {number} length - 长度
         * @param {number} end - 结束值
         *
         * @returns {Object}
         *  .length: number - narrow的长度
         *  .points: Array - narrow的点集
         *  .distance: number - narrow的位置
         */
        let min_ = 65535;
        let min_s_ = [];
        let min_i_ = -1;

        const shape = get.shape(arr2d);
        const width = shape.x;
        const height = shape.y;

        if (direct === RIGHT) {
            for (let x = p0.x; x < width; x++) {
                let tmp = [];
                if (length === 0) break;
                length -= 1;
                for (let y = p0.y; y <= p1.y; y++) {
                    if (arr2d[y][x] < end) {
                        tmp.push({x, y});
                    }
                }
                if (tmp.length && tmp.length < min_) {
                    min_ = tmp.length;
                    min_s_ = tmp;
                    min_i_ = x;
                }
            }
        } else if (direct === LEFT) {
            for (let x = p0.x; x >= 0; x--) {
                let tmp = [];
                if (length === 0) break;
                length -= 1;
                for (let y = p0.y; y <= p1.y; y++) {
                    if (arr2d[y][x] < end) {
                        tmp.push({x, y});
                    }
                }
                if (tmp.length && tmp.length < min_) {
                    min_ = tmp.length;
                    min_s_ = tmp;
                    min_i_ = x;
                }
            }
        } else if (direct === BOTTOM) {
            for (let y = p0.y; y < height; y++) {
                let tmp = [];
                if (length === 0) break;
                length -= 1;
                for (let x = p0.x; x <= p1.x; x++) {
                    if (arr2d[y][x] < end) {
                        tmp.push({x, y});
                    }
                }
                if (tmp.length && tmp.length < min_) {
                    min_ = tmp.length;
                    min_s_ = tmp;
                    min_i_ = y;
                }
            }
        } else if (direct === TOP) {
            for (let y = p0.y; y >= 0; y--) {
                let tmp = [];
                if (length === 0) break;
                length -= 1;
                for (let x = p0.x; x <= p1.x; x++) {
                    if (arr2d[y][x] < end) {
                        tmp.push({x, y});
                    }
                }
                if (tmp.length && tmp.length < min_) {
                    min_ = tmp.length;
                    min_s_ = tmp;
                    min_i_ = y;
                }
            }
        }

        return {
            length: min_,
            points: min_s_,
            distance: min_i_
        };
    },
    marksMap: function (arr2d, value, ...points) {
        if (points.length === 0) {
            return;
        }
        const shape = get.shape(arr2d);
        for (let i = 0; i < points.length; i++) {
            let p = points[i];
            if (p.x >= 0 && p.x < shape.x && p.y >= 0 && p.y < shape.y) {
                arr2d[p.y][p.x] = value;
            }
        }
    },
    SWAMP_RATIO:0,
    swampRatio: function (arr2d) {
        let swamp_cells = 0;
        let accessible_cells = 0;
        const shape = get.shape(arr2d);
        for (let y = 0; y < shape.y; y++) {
            for (let x = 0; x < shape.x; x++) {
                if (arr2d[y][x] === 10) {
                    swamp_cells += 1;
                }
                if (arr2d[y][x] < 255) {
                    accessible_cells += 1;
                }
            }
        }
        return swamp_cells / accessible_cells;
    },
}

function __init_my_exists_creep_before_k__(){
    const objs = getObjectsByPrototype(Creep);
    for (const obj of objs) {
        if (obj.my){
            obj.__spawn__ = true;
        }
    }
}

// new COST_ARRAY2D
get.COST_ARRAY2D = get.costArray2D({x: 0, y: 0}, {x: 100, y: 100}, true);
for (let ih = 0; ih < 100; ih++) {
    for (let iw = 0; iw < 100; iw++) {
        get.COST_MATRIX.set(iw, ih, get.COST_ARRAY2D[ih][iw]);
    }
}

get.SWAMP_RATIO = get.swampRatio(get.COST_ARRAY2D);
get.P2 = get.pooling(get.COST_ARRAY2D, 2);
get.P4 = get.pooling(get.P2, 2);
get.P5 = get.pooling(get.COST_ARRAY2D, 5);
get.P8 = get.pooling(get.P4, 2);
get.P10 = get.pooling(get.P5, 2);

const COST_MATRIX_LIBS = {
    default: get.COST_MATRIX.clone(),
    swamp: get.COST_MATRIX.clone(),
    set(x, y, cost){
        this.default.set(x, y, cost);
        this.swamp.set(x, y, cost);
    }
}

for (let y = 0; y < 100; y++) {
    for (let x = 0; x < 100; x++) {
        if (COST_MATRIX_LIBS.default.get(x, y) === 10) {
            COST_MATRIX_LIBS.swamp.set(x, y, 2);
        }
    }
}

const DEFAULT_MOTION = {
    costMatrix: COST_MATRIX_LIBS.default,
    flee: false,
    maxOps: 50000,
    maxCost: Infinity,
    heuristicWeight: 1.2,
    clone(){
        return {
            costMatrix: this.costMatrix.clone(),
            flee: this.flee,
            maxOps: this.maxOps,
            maxCost: this.maxCost,
            heuristicWeight: this.heuristicWeight,
        }
    }

};
const SWAMP_MOTION = {
    costMatrix: COST_MATRIX_LIBS.swamp,
    flee: false,
    maxOps: 50000,
    maxCost: Infinity,
    heuristicWeight: 1.2,
    clone(){
        return {
            costMatrix: this.costMatrix.clone(),
            flee: this.flee,
            maxOps: this.maxOps,
            maxCost: this.maxCost,
            heuristicWeight: this.heuristicWeight,
        }
    }
};



